/***************************************
  $Revision: 1.2 $

  Error reporting (er) er_ER_errors.{m4,h} - definition of errors for the 
                              error reporting module

  Status: NOT REVUED, TESTED, 

  Design and implementation by: Marek Bukowy

  ******************/ /******************
  Copyright (c) 1999                              RIPE NCC
 
  All Rights Reserved
  
  Permission to use, copy, modify, and distribute this software and its
  documentation for any purpose and without fee is hereby granted,
  provided that the above copyright notice appear in all copies and that
  both that copyright notice and this permission notice appear in
  supporting documentation, and that the name of the author not be
  used in advertising or publicity pertaining to distribution of the
  software without specific, written prior permission.
  
  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
  AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
  DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  ***************************************/

/* 
NOTE:  modify the m4 file only, do not change the resulting .h !!!
*/

/* use m4 macros to keep stuff in sync */




     /******************************************/
     /* ***** DEFINE THE CURRENT FACILITY **** */
     /* * make sure no whitespaces are inside! */
     /* */               /* */
     /* ************************************** */
     /******************************************/

/* last thing: disable processing of commented text (this allows to comment
   out some macro entries. Alas, the #%$@&* designers screwed up, so now we
   have to manually disable messing with C preprocessor commands */





typedef enum {
  /*  fac  code    sev  descr
      
      current facility specified inside the line below as CFAC
   */

   LOW_AC_OK ,
   LOW_AC_INVARG ,
   LOW_AC_INTR_ERR ,
} AC_err_code_t;

/* paste the #define'd codes */
#define AC_OK  (ER_SEV_I + (FAC_AC<<16) + LOW_AC_OK)
#define AC_INVARG  (ER_SEV_E + (FAC_AC<<16) + LOW_AC_INVARG)
#define AC_INTR_ERR  (ER_SEV_E + (FAC_AC<<16) + LOW_AC_INTR_ERR)
 

#ifdef ER_IMPL
er_list_t AC_mod_err[]={

  /* paste the ERDUP's */
    { ERDUP(AC_OK),"OK" },
  { ERDUP(AC_INVARG),"invalid argument" },
  { ERDUP(AC_INTR_ERR),"internal error" },
 
  
  ER_LASTTXT
};
#endif /* ER_IMPL */
