/***************************************
  $Revision:

  CA module: a wrapper for the functions which parse the
             dictionary, configuration and source files.

  Status: NOT REVIEWED, NOT TESTED

  Author(s):       Ambrose Magee

******************//******************
Modification History:

******************/

/************************************
Copyright (c) 2000                              RIPE NCC

All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of the author not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
***************************************/


/* m4 macro */
define(`ADAPT', ` divert(9) dnl
{"$1", "CA_$1",  "CA_$2", CA_$1, $3},
divert(8) dnl
 CA_$1,
divert')

#define CAP_W 0x000001
#define CAP_U 0x000002



ADAPT(TESTMODE, BOOLEAN, 1)
ADAPT(OVERRIDECRYPTEDPW, STRING, 1)
ADAPT(AUTODBMHELP, DIRLIST, 1)
ADAPT(CROSSNOTIFYSOURCES, STRING, 1)
ADAPT(UPDLOG, DIRLIST, 1)
ADAPT(ACKLOG, DIRLIST, 1)
ADAPT(LOCKDIR, DIRLIST, 1)
ADAPT(UPDATELOCK, STRING, 1)
ADAPT(KEEPOPEN, INT, 1)
ADAPT(ALLOCMNT, STRING, 1)
ADAPT(WHOISUPDFROM, STRING, 1)
ADAPT(TMPDIR, DIRLIST, 1)
ADAPT(GPGCMD, DIRLIST, 1)
ADAPT(PGPPATH, DIRLIST, 1)
ADAPT(MAILCMD, DIRLIST, 1)
ADAPT(HUMAILBOX, STRING, 1)
ADAPT(AUTOBOX, STRING, 1)
ADAPT(DEFMAIL, STRING, 1)
ADAPT(DUPLICATEPERSONCHECK, STRING, 1)
ADAPT(CN_SUBJECT_ADD, STRING, 1)
ADAPT(CN_SUBJECT_DEL, STRING, 1)
ADAPT(CN_EXPLAIN_ADD, STRING, 1)
ADAPT(CN_EXPLAIN_DEL, STRING, 1)
ADAPT(CN_OVERLAP_ADD, STRING, 1)
ADAPT(CN_OVERLAP_DEL, STRING, 1)
ADAPT(CNO_SUBJECT_ADD, STRING, 1)
ADAPT(CNO_SUBJECT_DEL, STRING, 1)
ADAPT(CNO_EXPLAIN_ADD, STRING, 1)
ADAPT(CNO_EXPLAIN_DEL, STRING, 1)
ADAPT(CNO_OVERLAP_ADD, STRING, 1)
ADAPT(CNO_OVERLAP_DEL, STRING, 1)
ADAPT(MAILTXT, STRING, 1)
ADAPT(MHEADER, STRING, 1)
ADAPT(FAILURETXT, STRING, 1)
ADAPT(SUCCESSTXT, STRING, 1)
ADAPT(HELPHEADER, STRING, 1)
ADAPT(ACKERR, STRING, 1)
ADAPT(ACKOK, STRING, 1)
ADAPT(ACKSIG, STRING, 1)
ADAPT(NOTITXT, STRING, 1)
ADAPT(NOTIMAILTXT, STRING, 1)
ADAPT(NOTINETWORKTXT, STRING, 1)
ADAPT(NHEADER, STRING, 1)
ADAPT(FWHEADER, STRING, 1)
ADAPT(FWTXT, STRING, 1)
ADAPT(FWMAILTXT, STRING, 1)
ADAPT(FWNETWORKTXT, STRING, 1)
ADAPT(MTFWHEADER, STRING, 1)
ADAPT(MTFWTXT, STRING, 1)
ADAPT(REFERRALTIMEOUT, INT, 1)
ADAPT(REFERRALMAXLINES, INT, 1)
ADAPT(COUNTRY, STRING, 1)
ADAPT(RIPADMIN, ADMIN, 1)
ADAPT(NOTIFLOG, DIRLIST, 1)
ADAPT(FORWLOG, DIRLIST, 1)
ADAPT(CROSSLOG, DIRLIST, 1)
ADAPT(UPDSOURCE, UPDSOURCE, 1)
ADAPT(SVWHOIS_PORT, INT, 1)
ADAPT(SVCONFIG_PORT, INT, 1)
ADAPT(SVMIRROR_PORT, INT, 1)
ADAPT(SOURCEFILE, DIRLIST, 1)
ADAPT(AC_DECAY_INTERVAL, INT, 1)
ADAPT(AC_DECAY_HALFLIFE, INT, 1)
ADAPT(PW_RESP_HEADER, STRING, 1)
ADAPT(PW_ERR_NOKEY, STRING, 1)
ADAPT(PW_HELP_FILE, DIRLIST, 1)
ADAPT(PW_K_FILTER, STRING, 1)
ADAPT(PW_LIMIT_REACHED, STRING, 1)
ADAPT(PW_ACL_ADDRPASS, STRING, 1)
ADAPT(PW_ACL_PERMDENY, STRING, 1)
ADAPT(PW_NOTFOUND, STRING, 1)
ADAPT(PW_CONNCLOSED, STRING, 1)
ADAPT(PW_BANNER, STRING, 1)
ADAPT(QC_BADATTR, STRING, 1)
ADAPT(QC_FMT_ATTRNOTINV, STRING, 1)
ADAPT(QC_FMT_BADSOURCE, STRING, 1)
ADAPT(QC_BADOBJTYPE, STRING, 1)
ADAPT(QI_REF_TMOUT, STRING, 1)
ADAPT(QI_REF_OVERMAXLIN, STRING, 1)
ADAPT(QI_REF_BADHOST, STRING, 1)
ADAPT(QI_REF_HOSTNOTTRESP, STRING, 1)
ADAPT(QI_FMT_REFHEADER, STRING, 1)
ADAPT(ER_DEF, STRING, 1)
ADAPT(ER_MACRO, STRING, 1)
ADAPT(ER_UD_DEF, DIRLIST, 1)
ADAPT(QI_REFTRAILER, STRING, 1)
 

typedef enum {

	undivert(8)

	CA_NUMBEROFSYMBOLS

} ca_dictsym;
 
#ifndef DICT_INIT
extern dict_t dictionary[];
#else 
dict_t dictionary[] = {
  undivert(9)

  {"", "", "", CA_NUMBEROFSYMBOLS, 1}
};
#endif

