typedef union {
   long long int      i;
   double             real;
   char              *string;
   void              *ptr;
   time_t             time;
   Item              *item;
   ItemList          *list;
   regexp            *re;
   SymID              sid;
   IPAddr            *ip;
   Prefix            *prfx;
   PrefixRange       *prfxrng;
   RPType            *typenode;

   Filter                    *filter;
   FilterMS                  *moreSpecOp;
   PolicyPeering             *peering;
   PolicyActionList          *actionList;
   PolicyAction              *actionNode;
   PolicyFactor              *policyFactor;
   PolicyTerm                *policyTerm;
   PolicyExpr                *policyExpr;
   List<PolicyPeeringAction> *peeringActionList;

   Attr               *attr;
   AttrAttr           *rpslattr;
   AttrMethod         *method;
   const AttrRPAttr   *rp_attr;
   const AttrProtocol *protocol;
   AttrProtocolOption *protocol_option;
   List<AttrProtocolOption> *protocol_option_list;

   AttrPeerOption       *peer_option;
   List<AttrPeerOption> *peer_option_list;

   List<RPTypeNode> *typelist;
   List<AttrMethod> *methodlist;
   List<WordNode>   *wordlist;

   List<AttrMntRoutes::MntPrfxPair> *listMntPrfxPair;
   AttrMntRoutes::MntPrfxPair       *mntPrfxPair;
} YYSTYPE;
#define	KEYW_TRUE	257
#define	KEYW_FALSE	258
#define	KEYW_ACTION	259
#define	KEYW_ACCEPT	260
#define	KEYW_ANNOUNCE	261
#define	KEYW_FROM	262
#define	KEYW_TO	263
#define	KEYW_AT	264
#define	KEYW_ANY	265
#define	KEYW_REFINE	266
#define	KEYW_EXCEPT	267
#define	KEYW_STATIC	268
#define	KEYW_NETWORKS	269
#define	KEYW_MASKLEN	270
#define	KEYW_UNION	271
#define	KEYW_RANGE	272
#define	KEYW_LIST	273
#define	KEYW_OF	274
#define	KEYW_OPERATOR	275
#define	KEYW_SYNTAX	276
#define	KEYW_SPECIAL	277
#define	KEYW_OPTIONAL	278
#define	KEYW_MANDATORY	279
#define	KEYW_INTERNAL	280
#define	KEYW_SINGLEVALUED	281
#define	KEYW_MULTIVALUED	282
#define	KEYW_LOOKUP	283
#define	KEYW_KEY	284
#define	KEYW_DELETED	285
#define	KEYW_GENERATED	286
#define	KEYW_OBSOLETE	287
#define	KEYW_PEERAS	288
#define	KEYW_PROTOCOL	289
#define	KEYW_INTO	290
#define	KEYW_ATOMIC	291
#define	KEYW_INBOUND	292
#define	KEYW_OUTBOUND	293
#define	KEYW_UPON	294
#define	KEYW_HAVE_COMPONENTS	295
#define	KEYW_EXCLUDE	296
#define	KEYW_NONE	297
#define	KEYW_MAILFROM	298
#define	KEYW_CRYPTPW	299
#define	KEYW_ASSIGNED	300
#define	KEYW_ALLOCATED	301
#define	KEYW_PI	302
#define	KEYW_PA	303
#define	KEYW_UNSPECIFIED	304
#define	KEYW_EXT	305
#define	KEYW_SIMPLE	306
#define	KEYW_RIPE	307
#define	KEYW_INTERNIC	308
#define	KEYW_CLIENTADDRESS	309
#define	TKN_ERROR	310
#define	TKN_UNKNOWN_CLASS	311
#define	TKN_EOA	312
#define	TKN_EOO	313
#define	TKN_FREETEXT	314
#define	TKN_INT	315
#define	TKN_REAL	316
#define	TKN_STRING	317
#define	TKN_TIMESTAMP	318
#define	TKN_BLOB	319
#define	TKN_IPV4	320
#define	TKN_PRFXV6	321
#define	TKN_PRFXV4	322
#define	TKN_PRFXV4RNG	323
#define	TKN_ASNO	324
#define	TKN_ASNAME	325
#define	TKN_RSNAME	326
#define	TKN_RTRSNAME	327
#define	TKN_PRNGNAME	328
#define	TKN_FLTRNAME	329
#define	TKN_BOOLEAN	330
#define	TKN_WORD	331
#define	TKN_RP_ATTR	332
#define	TKN_DNS	333
#define	TKN_EMAIL	334
#define	TKN_3DOTS	335
#define	TKN_NICHDL	336
#define	TKN_KEYCRTNAME	337
#define	TKN_CRYPTEDPW	338
#define	ATTR_GENERIC	339
#define	ATTR_BLOBS	340
#define	ATTR_IMPORT	341
#define	ATTR_EXPORT	342
#define	ATTR_DEFAULT	343
#define	ATTR_FREETEXT	344
#define	ATTR_CHANGED	345
#define	ATTR_IFADDR	346
#define	ATTR_PEER	347
#define	ATTR_INJECT	348
#define	ATTR_COMPONENTS	349
#define	ATTR_AGGR_MTD	350
#define	ATTR_AGGR_BNDRY	351
#define	ATTR_RS_MEMBERS	352
#define	ATTR_RP_ATTR	353
#define	ATTR_TYPEDEF	354
#define	ATTR_PROTOCOL	355
#define	ATTR_FILTER	356
#define	ATTR_PEERING	357
#define	ATTR_ATTR	358
#define	ATTR_MNT_ROUTES	359
#define	ATTR_NICHDL	360
#define	ATTR_AUTH	361
#define	ATTR_STATUS_INET	362
#define	ATTR_PHONE	363
#define	ATTR_SOURCE	364
#define	ATTR_REFER	365
#define	ATTR_COUNTRY	366
#define	ATTR_PERSON	367
#define	OP_OR	368
#define	OP_AND	369
#define	OP_NOT	370
#define	OP_MS	371
#define	TKN_OPERATOR	372


extern YYSTYPE rpsllval;
